package de.w665.fluidcms.db;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.net.Connection;
import jakarta.annotation.PostConstruct;
import jakarta.annotation.PreDestroy;
import jakarta.inject.Inject;
import jakarta.inject.Singleton;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Singleton
@RequiredArgsConstructor
@Getter
public class RethinkDBConnector {

    @Inject
    RethinkDBConfig config;

    private final RethinkDB r = RethinkDB.r;
    private Connection connection;

    @PostConstruct
    public void connectToDatabase() {
        connection = r.connection().hostname(config.getHost()).port(config.getPort()).connect();
        log.info("Connected to RethinkDB at " + config.getHost() + ":" + config.getPort() + " on database " + config.getDatabase());
    }

    @PreDestroy
    public void closeConnection() {
        if (connection != null) {
            connection.close();
        }
    }
}