package de.w665.fluidcms.db.repo;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.net.Connection;
import de.w665.fluidcms.db.RethinkDBConfig;
import de.w665.fluidcms.db.RethinkDBConnector;
import jakarta.annotation.PostConstruct;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class TestRepo {

    @Inject
    RethinkDBConnector connector;

    @Inject
    RethinkDBConfig config;

    private final String TABLE_NAME = "test";
    private RethinkDB r;
    private Connection connection;

    @PostConstruct
    public void init() {
        this.r = this.connector.getR();
        this.connection = this.connector.getConnection();

        // Check if table exists
        try {
            r.db(config.getDatabase()).tableCreate(TABLE_NAME).run(connection);
            log.debug("Table " + TABLE_NAME + " created");
        } catch (Exception e) {
            log.debug("Table " + TABLE_NAME + " already exists");
        }
    }

    public void insert(String value) {
        r.db(config.getDatabase()).table(TABLE_NAME).insert(r.hashMap("value", value)).run(connection);
    }
}
