package de.w665.fluidcms.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import de.w665.fluidcms.model.objectattributes.StringObjectAttribute;
import lombok.Getter;
import lombok.Setter;

@Setter
@Getter
@JsonTypeInfo(
        use = JsonTypeInfo.Id.NAME,
        property = "type")
@JsonSubTypes({
        @JsonSubTypes.Type(value = StringObjectAttribute.class, name = "String"),
})
public abstract class ObjectAttribute <T> {
    private String type;
    private String name;
    private String description;
    private boolean required;
    private T defaultValue;

    public ObjectAttribute() {
        this.type = this.getClass().getSimpleName();
    }

    @JsonIgnore
    public abstract String getValueAsString();
    public abstract T getValue();
    public abstract void setValue(T value);
    public abstract boolean verifyValueType(Object value);
}
