package de.w665.fluidcms.rest.mapping;

import de.w665.fluidcms.db.repo.ObjectTypeRepository;
import de.w665.fluidcms.model.ObjectAttribute;
import de.w665.fluidcms.model.ObjectType;
import de.w665.fluidcms.model.objectattributes.StringObjectAttribute;
import jakarta.inject.Inject;
import jakarta.ws.rs.*;
import lombok.extern.slf4j.Slf4j;
import org.jboss.resteasy.reactive.RestResponse;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Path("/objectType")
public class ObjectTypeResource {

    @Inject
    ObjectTypeRepository objectTypeRepository;

    @POST
    @Consumes("application/json")
    @Produces("application/json")
    public RestResponse<ObjectType> createObjectType(ObjectType objectType) {
        log.debug(objectType.toString());
        objectTypeRepository.insert(objectType);
        return RestResponse.ok(objectType);
    }

    @GET
    @Produces("application/json")
    public RestResponse<ObjectType> getObjectType() {
        StringObjectAttribute attr1 = new StringObjectAttribute();
        String number = String.valueOf((int) (Math.random() * 100));
        attr1.setName("Attribute " + number);
        attr1.setDescription("This is attribute " + number);
        attr1.setRequired(true);
        attr1.setDefaultValue("Default Value " + number);
        attr1.setValue("Attribute " + number + " Value");

        number = String.valueOf((int) (Math.random() * 100));
        StringObjectAttribute attr2 = new StringObjectAttribute();
        attr2.setName("Attribute " + number);
        attr2.setDescription("This is attribute " + number);
        attr2.setRequired(false);
        attr2.setDefaultValue("Default Value " + number);
        attr2.setValue("Attribute " + number + " Value");

        // Add the StringObjectAttribute objects to a Map
        List<ObjectAttribute> attributes = new ArrayList<>();
        attributes.add(attr1);
        attributes.add(attr2);

        // Create an ObjectType object and set the attributes
        ObjectType objectType = new ObjectType();
        objectType.setId("123");

        number = String.valueOf((int) (Math.random() * 100));
        objectType.setName("Object Type " + number);
        objectType.setDescription("This is object type  " + number);

        // random number

        objectType.setIcon("icon.png");
        objectType.setColor("blue");
        objectType.setAttributes(attributes);

        return RestResponse.ok(objectType);
    }
}
